function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Column, Entity, Index, JoinColumn, ManyToOne, PrimaryColumn } from "typeorm";
import { id } from "../id.js";
import { Note } from "./note.js";
export let InteractionStamp = class InteractionStamp {
    id;
    type;
    targetNoteId;
    targetNote;
    noteId;
    note;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], InteractionStamp.prototype, "id", void 0);
_ts_decorate([
    Column("enum", {
        enum: [
            "quote"
        ]
    }),
    _ts_metadata("design:type", String)
], InteractionStamp.prototype, "type", void 0);
_ts_decorate([
    Column(id()),
    _ts_metadata("design:type", Object)
], InteractionStamp.prototype, "targetNoteId", void 0);
_ts_decorate([
    ManyToOne((type)=>Note, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], InteractionStamp.prototype, "targetNote", void 0);
_ts_decorate([
    Column(id()),
    _ts_metadata("design:type", Object)
], InteractionStamp.prototype, "noteId", void 0);
_ts_decorate([
    ManyToOne((type)=>Note, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], InteractionStamp.prototype, "note", void 0);
InteractionStamp = _ts_decorate([
    Entity(),
    Index([
        "noteId",
        "targetNoteId"
    ], {
        unique: true
    })
], InteractionStamp);
